#include <stdio.h>
#include <time.h>
#include <string.h>

#include "fileio.h"

extern int old_mode;
extern int sound;
extern int herz_sound;
extern int leben;
extern int stops;
extern int allpunkte, punkte;
extern int level;
extern int feld[1170];
extern int oldlevel, x, y, richtung, dopsrichtung, closeme, loadnewlevel, waitforspace, 
	oldx, oldy, insmooth, pacok, pacinsmooth;
extern int oldpunkte, bonus, bonustime, zeit, firsttry;
extern char statustext[512];
extern char timetext[512];
extern int pac4[32][3];
extern int pac5[32][3];
extern int oldpac4[32][3];
extern int oldpac5[32][3];
//extern int counter, curSkip, maxSkip, tempint, smoothpixels, kollision, herzda;
extern char spruch[512];
extern volatile int abgelaufen;
extern int weiterspielen;


typedef struct
{
	int old_mode;
	int sound;
	int herz_sound;
	int leben;
	int stops;
	int allpunkte, punkte;
	int level;
	int feld[1170];
	int oldlevel, x, y, richtung, dopsrichtung, closeme, loadnewlevel, waitforspace, 
		oldx, oldy, insmooth, pacok, pacinsmooth;
	int oldpunkte, bonus, bonustime, zeit, firsttry;
	char statustext[512];
	char timetext[512];
	int pac4[32][3];
	int pac5[32][3];
	int oldpac4[32][3];
	int oldpac5[32][3];
	//int counter, curSkip, maxSkip, tempint, smoothpixels, kollision, herzda;
	char spruch[512];
	int abgelaufen;
	int weiterspielen;
} game_data_t;

static int decode(int zeichen);
static long Bin_Dez(char a[]);
static void Dez_Bin(long dez,char a[]);
static void Dez_Hex(long dez,char a[]);


int get_spruch(int number, char *spruch)
{
	FILE * fspruch;
	char tempchar[512];
	int counter;
	
	//Datei ffnen
	if((fspruch=fopen("data/spruch","rt"))==NULL)
		//Fehler beim ffnen
		return 1;

	//zu angegebenem spruch springen,
	for(counter=0;counter<number;counter++)
		if(fgets(tempchar, 512, fspruch)==NULL)
		{
			fclose(fspruch);
			return 2;
		}
	//angegebenen spruch einlesen...
	if(fgets(tempchar, 512, fspruch)==NULL)
	{
		fclose(fspruch);
		return 2;
	}
	//...und metazeichen entfernen
	memcpy(spruch, tempchar+6, strlen(tempchar)-8);
	*(spruch+strlen(tempchar)-8)='\0';
	
	//Datei wieder schlieen
	fclose(fspruch);
	return 0;
}

int load_game(void)
{
	game_data_t ziel;
	FILE * fsave;
	int xc;
	char data[sizeof(game_data_t)];

	//Datei ffnen
	if((fsave=fopen("data/save.dat","rb"))==NULL)
		//Fehler beim ffnen
		return 1;
	fseek(fsave, 0, SEEK_SET);
	for(xc=0;xc<sizeof(game_data_t);xc++)
	{
		if(feof(fsave)!=0)
		{
			fclose(fsave);
			return 2;
		}
		data[xc]=fgetc(fsave);
	}
	memcpy(&ziel, data, sizeof(game_data_t));
	
	old_mode=ziel.old_mode;
	sound=ziel.sound;
	herz_sound=ziel.herz_sound;
	leben=ziel.leben;
	stops=ziel.stops;
	allpunkte=ziel.allpunkte;
	punkte=ziel.punkte;
	level=ziel.level;
	memcpy(feld, ziel.feld, sizeof(int)*1170);
	oldlevel=ziel.oldlevel;
	x=ziel.x;
	y=ziel.y;
	richtung=ziel.richtung;
	dopsrichtung=ziel.dopsrichtung;
	loadnewlevel=ziel.loadnewlevel;
	waitforspace=ziel.waitforspace; 
	oldx=ziel.oldx;
	oldy=ziel.oldy;
	insmooth=ziel.insmooth;
	pacok=ziel.pacok;
	pacinsmooth=ziel.pacinsmooth;
	oldpunkte=ziel.oldpunkte;
	bonus=ziel.bonus;
	bonustime=ziel.bonustime;
	zeit=ziel.zeit;
	firsttry=ziel.firsttry;
	memcpy(&ziel.statustext, statustext, sizeof(char)*512);
	memcpy(&ziel.timetext, timetext, sizeof(char)*512);	
	memcpy(&pac4, &ziel.pac4, sizeof(int)*32*3);
	memcpy(&pac5, &ziel.pac5, sizeof(int)*32*3);
	memcpy(&oldpac4, &ziel.oldpac4, sizeof(int)*32*3);
	memcpy(&oldpac5, &ziel.oldpac5, sizeof(int)*32*3);
//	levelstart=ziel.levelstart;
//	pausetime=ziel.pausetime;
//	temptime=ziel.temptime;
//	counter=ziel.counter;
//	curSkip=ziel.curSkip;
//	maxSkip=ziel.maxSkip;
//	tempint=ziel.tempint;
//	smoothpixels=ziel.smoothpixels;
//	kollision=ziel.kollision;
//	herzda=ziel.herzda;
	memcpy(ziel.spruch, spruch, sizeof(char)*512);
	abgelaufen=ziel.abgelaufen;
	weiterspielen=ziel.weiterspielen;

	return 0;
}

int save_game(void)
{
	game_data_t ziel;
	FILE * fsave;
	int xc;
	char data[sizeof(game_data_t)];
	
	ziel.old_mode=old_mode;
	ziel.sound=sound;
	ziel.herz_sound=herz_sound;
	ziel.leben=leben;
	ziel.stops=stops;
	ziel.allpunkte=allpunkte;
	ziel.punkte=punkte;
	ziel.level=level;
	memcpy(ziel.feld, feld, sizeof(int)*1170);
	ziel.oldlevel=oldlevel;
	ziel.x=x;
	ziel.y=y;
	ziel.richtung=richtung;
	ziel.dopsrichtung=dopsrichtung;
	ziel.loadnewlevel=loadnewlevel;
	ziel.waitforspace=waitforspace; 
	ziel.oldx=oldx;
	ziel.oldy=oldy;
	ziel.insmooth=insmooth;
	ziel.pacok=pacok;
	ziel.pacinsmooth=pacinsmooth;
	ziel.oldpunkte=oldpunkte;
	ziel.bonus=bonus;
	ziel.bonustime=bonustime;
	ziel.zeit=zeit;
	ziel.firsttry=firsttry;
	memcpy(&ziel.statustext, statustext, sizeof(char)*512);
	memcpy(&ziel.timetext, timetext, sizeof(char)*512);	
	memcpy(&ziel.pac4, &pac4, sizeof(int)*32*3);
	memcpy(&ziel.pac5, &pac5, sizeof(int)*32*3);
	memcpy(&ziel.oldpac4, &oldpac4, sizeof(int)*32*3);
	memcpy(&ziel.oldpac5, &oldpac5, sizeof(int)*32*3);
//	ziel.levelstart=levelstart;
//	ziel.pausetime=pausetime;
//	ziel.temptime=temptime;
//	ziel.counter=counter;
//	ziel.curSkip=curSkip;
//	ziel.maxSkip=maxSkip;
//	ziel.tempint=tempint;
//	ziel.smoothpixels=smoothpixels;
//	ziel.kollision=kollision;
//	ziel.herzda=herzda;
	memcpy(spruch, ziel.spruch, sizeof(char)*512);
	ziel.abgelaufen=abgelaufen;
	ziel.weiterspielen=weiterspielen;
	
	memcpy(data, &ziel, sizeof(game_data_t));
	//Datei ffnen
	if((fsave=fopen("data/save.dat","wb"))==NULL)
		//Fehler beim ffnen
		return 1;
	fseek(fsave, 0, SEEK_SET);
	for(xc=0;xc<sizeof(game_data_t);xc++)
	{
		if(feof(fsave)!=0)
		{
			fclose(fsave);
			return 2;
		}
		fputc(data[xc], fsave);
	}
	return 0;
}

int loadlevel(int level, int *spielfeld)
{
	int x;
	int value;
	char hexvalue[3];
	FILE * flevel;
	
	
	//Datei ffnen
	if((flevel=fopen("data/level.dat","rb"))==NULL)
		//Fehler beim ffnen
		return 1;

	//An die Position des Levels in der Datei springen	
	fseek(flevel, 160+584*(level-1), SEEK_SET);
	//Zeit fr bonus einlesen
	spielfeld[0]=decode(fgetc(flevel));
	//Spielfeld einlesen
	for(x=1;x<(584*2)+1;x+=2)
	{
		if(feof(flevel)!=0)
		{
			fclose(flevel);
			return 2;
		}
		value=decode(fgetc(flevel));
		Dez_Hex(value,hexvalue);
		spielfeld[x]=hexvalue[0]-48;
		spielfeld[x+1]=hexvalue[1]-48;
	}
	
	//Datei wieder schlieen
	fclose(flevel);
	return 0;
}

//Decodieren eines binrzeichens
int decode(int zeichen)
{
	char binaerzahl[9];
	char decodiert[9];
	
	Dez_Bin(zeichen, binaerzahl);
	decodiert[0]=binaerzahl[0];
	decodiert[1]=binaerzahl[2];
	decodiert[2]=binaerzahl[4];
	decodiert[3]=binaerzahl[6];
	decodiert[4]=binaerzahl[7];
	decodiert[5]=binaerzahl[5];
	decodiert[6]=binaerzahl[3];
	decodiert[7]=binaerzahl[1];
	decodiert[8]='\0';
	return Bin_Dez(decodiert);
}


// ************************************************** Umwandlungsfunktionen **************************************************
void Dez_Bin(long dez,char a[]) 
{ 
	int r,x=0; 
	
	for(r=0;r<8;r++)
		a[r]=48;
	a[8]='\0';
	
	for(r=128;r>=1;r/=2)
		if((dez/r)!=0)
		{
			a[x++]=49;
			dez-=r;
		}
		else
			x++;
} 
 
long Bin_Dez(char a[]) 
{ 
	int f,n,s; 
 
	n=strlen(a); 
	f=1; s=0; 
	for(n=n-1;n>=0;n--) 
	{ 
		s+=((int)a[n]-48)*f; 
		f=f*2; 
	}
	return s; 
}

void Dez_Hex(long dez,char a[]) 
{ 
	long r;
	
	r=dez/16;
	if(r<10)
		a[0]=48+r;
	else
		a[0]=55+r;
	
	r=dez%16;
	if(r<10)
		a[1]=48+r;
	else
		a[1]=55+r;
	
	a[2]='\0';
	return;
}
