//DONE hilfefenster: rest wird ausgegraut
//DONE hilfe muss auch bei pause aufgerufen werden knnen
//DONE tasten fr musik/sound in eigenen thread auslagern
//DONE taste fr vollbild mglicherweise auch auslagern oder berall verfgbar machen
//DONE soundstatus auch in saved gamestate aufnehmen
//DONE in zeile 124 muss der komentar noch weg, wenn Tim fertig ist mit GameOver und anzahl der leben muss wieder von 1 auf 99 gestellt werden 
//DONE Pacman-Bug muss noch behoben werden (darf nicht hpfen, wenn eingeschlossen)
//DONE ESC Taste lsst weiterspielen, auch wenn weiterspielen=disabled
//DONE Spruch bug beheben (spruch wird erst ab level 5 angezeigt)
//DONE pacmans verschwinden, wenn man level geschaft hat und der spruch geblendet wird

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <pthread.h>
#include <allegro.h>
#ifdef _WIN32
	#include <winalleg.h>
#endif

#include "fileio.h"
#include "grafik.h"
#include "menu.h"
#include "net.h"

#define _WAITFORKEY_		1
#define timer_interval		10
//12.5 positionsnderungen (im rasterfeld) pro sekunde
#define	_FPS_			( (int) (25.0/(((double)smoothpixels)/8.0)) )
#define	_BLEND_FPS_		( (int) (32.0) )
#define	_SPRUCH_FPS_		( (int) (128.0) )
#define _LEVEL_SKIP_		( (int) (03.0) )
#define _BLEND_SKIP_		( (int) (03.0) )
#define _SPRUCH_SKIP_		( (int) (08.0) )

#define _MUSIC_GAME_		0x01
#define _MUSIC_MENU_		0x02

void reset_sem(sem_t*, int);
void do_game_over(int);
void run_menu_blender(void);
void run_message_blender(int, int, int);
int do_jumper_menu(void);
void reset_window(void);
void close_jumper(void);
void run_level_blender(void);
inline float zeit_vergangen(void);

sem_t frame_sem;
int no_frame=0;
int global_frame_counter=0, loop_counter;
int control_frames, control_count, control_omit=0, control_grenze=0;;
static void frametimer()
{
	if(!no_frame)
	{
		sem_post(&frame_sem);
		global_frame_counter++;
	}
} END_OF_FUNCTION(frametimer);

volatile int abgelaufen=0;
static void ablauftimer()
{
	abgelaufen++;
} END_OF_FUNCTION(ablauftimer);
int oldabgelaufen;

SAMPLE *menu_sample=NULL;
SAMPLE *game_sample=NULL;
SAMPLE *heart_sample=NULL;
int music_playing=0;
void stop_playback(int sound)
{
	if(sound==_MUSIC_MENU_)
		stop_sample(menu_sample);
	else if(sound==_MUSIC_GAME_)
		stop_sample(game_sample);
	music_playing&=~sound;
	return;
}
void start_playback(int sound)
{
	if(sound==_MUSIC_MENU_)
		play_sample(menu_sample, 255, 128, 1000, TRUE);
	else if(sound==_MUSIC_GAME_)
		play_sample(game_sample, 255, 128, 1000, TRUE);
	music_playing|=sound;
	return;
}
pthread_t *key_thread_id;
int sound=1;
int herz_sound=1;
int sound_key=0, herz_key=0;
volatile int to_play=0;
volatile int run_key_thread=1;
void *key_thread(void *data)
{
	int old_play=-1;
	
	while(run_key_thread)
	{
		if(key[KEY_M])
		{
			if(!sound_key)
			{
				if(sound)
				{
					stop_playback(_MUSIC_MENU_);
					stop_playback(_MUSIC_GAME_);
					sound=0;
				}
				else
				{
					old_play=-1;	//trigger invocation of start_playback(...)
					sound=1;
				}
				sound_key=1;
			}
		}
		else
			sound_key=0;
		
		if(to_play!=old_play)
		{
			old_play=to_play;
			if(sound)
			{
				stop_playback(_MUSIC_MENU_);
				stop_playback(_MUSIC_GAME_);
				if(to_play==_MUSIC_GAME_)
					start_playback(_MUSIC_GAME_);
				if(to_play==_MUSIC_MENU_)
					start_playback(_MUSIC_MENU_);
			}
		}
		
		if(key[KEY_S])
		{
			if(!herz_key)
			{
				herz_sound=!herz_sound;
				herz_key=1;
			}
		}
		else
			herz_key=0;
		
		if(key[KEY_F])
			reset_window();
		
		rest(25);
	}
	
	return NULL;
}

int first_menu=0;
int back_num=0;
int back_key=0;
int leben;
int stops;
int allpunkte, punkte;
int level;
int old_mode;
int feld[1170];
int remote_feld[1170];
int oldlevel, x, y, richtung, dopsrichtung, closeme, loadnewlevel, waitforspace, 
	oldx, oldy, insmooth, pacok, pacinsmooth;
int oldpunkte, bonus, bonustime, zeit, firsttry;
char statustext[512];
char timetext[512];
int pac4[32][3];
int pac5[32][3];
int oldpac4[32][3];
int oldpac5[32][3];
int counter, curSkip, maxSkip, tempint, smoothpixels, kollision, herzda;
char spruch[512];

int weiterspielen=0;
int netzwerk=0;
int remote_x, remote_y;
int missed_messages=0;
int sync_levels;
int message_result;


void reset_sem(sem_t *sem, int value)
{
	int c;
	
	//semaphore auf 0 dekrementieren
	while(sem_trywait(&frame_sem)==0)
		;
	//semaphore auf bergebenen wert incrementieren
	for(c=0;c<value;c++)
		sem_post(sem);
	return;
}


int main(int argc, char **argv)
{
	old_mode=_FULLSCREEN_;	// _WINDOW_ _FULLSCREEN_
	smoothpixels=8;
	maxSkip=_LEVEL_SKIP_;
	
#ifdef _WIN32
	FreeConsole();
#endif
	allegro_init();
	install_keyboard();
	install_timer();
	install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL);
	menu_sample=load_wav("data/menu.wav");
	game_sample=load_sample("data/game.wav");
	heart_sample=load_sample("data/heart.wav");
	if(menu_sample==NULL || game_sample==NULL)
	{
		printf("ERROR: Konnte Sounddateien nicht laden...\n");
		exit(4);
	}
	
	load_game();	//nur fr old_mode, der rest wird spter noch einmal geladen (wenn nicht -> fehler im bonustimer)
	init_graphic();
	tempint=set_graphic_mode(800, 600, old_mode);
	set_screen_pos((SCREEN_W-640)/2, (SCREEN_H-480)/2);
	//Grafikmodus setzen
	if(tempint==1)
	{
		printf("ERROR: Grafikmodus nicht verfgbar\n");
		exit(1);
	}
	else if(tempint==2)
	{
		printf("ERROR: Konnte Bilddateien nicht laden...\n");
		exit(2);
	}
	else if(tempint==3)
	{
		printf("ERROR: Konnte keinen DoubleBuffer erstellen...\n");
		exit(3);
	}
	
	//randomize timer
	srand(time(NULL));
	//Funktion und Variable sperren
	LOCK_FUNCTION(frametimer);
	sem_init(&frame_sem, 0, 0);
	//Eine logische framerate von _fps_ einrichten
	if(install_int_ex(frametimer, BPS_TO_TIMER(_FPS_)))
	{
		printf("ERROR: Konnte den Interrupthandler fr die Framerate nicht registrieren...\n");
		exit(4);
	}
	//Funktion und Variable sperren
	LOCK_FUNCTION(ablauftimer);
	LOCK_VARIABLE(abgelaufen);
	//timer auf 100ms stellen
	if(install_int_ex(ablauftimer, BPS_TO_TIMER(timer_interval)))
	{
		printf("ERROR: Konnte den Interrupthandler fr den Timebonus nicht registrieren...\n");
		exit(5);
	}
	
	//Alle Tasten mssen losgelassen werden
	while(keypressed())
	{
		clear_keybuf();
		rest(25);
	}
	rest(500);
	
	key_thread_id=(pthread_t*)malloc(sizeof(pthread_t));
	pthread_create(key_thread_id, NULL, &key_thread, NULL);
	
	bonus=1;	
	abgelaufen=0;
	weiterspielen=1;
	init_jumper_menu();
	if(load_game())
		weiterspielen=0;
	oldabgelaufen=abgelaufen;
	while(1)
	{
		tempint=do_jumper_menu();
		
		if(tempint==2)
		{
			abgelaufen-=(abgelaufen-oldabgelaufen);
			save_game();		//Speichern
			do_game_over(4);
			run_message_blender(1, _DISSOLVE_, _WAITFORKEY_);		//0=help, 1=credits, 2=black
			run_message_blender(2, _TRANS_, !_WAITFORKEY_);			//0=help, 1=credits, 2=black
			rest(500);
			break;			//Beenden
		}
		
		if(tempint==0)
		{
			run_message_blender(0, _DISSOLVE_, _WAITFORKEY_);		//0=help, 1=credits, 2=black
			stop_playback(_MUSIC_MENU_);
			stop_playback(_MUSIC_GAME_);
			to_play=_MUSIC_GAME_;
			
			closeme=0;		//Spiel starten
			leben=99;
			stops=25;
			allpunkte=punkte=0;
			level=1;
			curSkip=0;
			loadnewlevel=1;
			oldlevel=-1;
			punkte=0;
			abgelaufen=0;
/*if(argc==2)
{
	int c;
	
	printf("DEBUG: opening client...\n");
	close_network();
	if(create_client(argv[1]))
	{
		printf("ERROR: Unbekannter Fehler (create, connect) / Unbekannter Host...\n");
		close_jumper();
	}
	
	do
	{
		c=wait_for_client_connect();
		if(key[KEY_ESC])
			close_jumper();
		rest(10);
	} while(!c);
	if(c==-1)
	{
		printf("ERROR: Die Gegenseite hat die Verbindung unerwartet beendet / Protokollversion des Servers stimmt nicht...\n");
		close_jumper();
	}
	else if(c==-2)
	{
		printf("ERROR: Kann nicht zu Server verbinden (Protokollversion stimmt nicht)...\n");
		close_jumper();
	}
	printf("DEBUG: client made connection...\n");
	netzwerk=2;
	for(counter=0;counter<1160;counter++)
		remote_feld[counter]=0;
	remote_x=-1;
	remote_y=-1;
	sync_levels=1;
}
if(argc==3)
{
	int c;
	
	printf("DEBUG: opening server...\n");
	close_network();
	if(create_server())
	{
		printf("ERROR: Kann Server nicht starten...\n");
		close_jumper();
	}
	
	do
	{
		c=wait_for_connect();
		if(key[KEY_ESC])
			close_jumper();
		rest(50);
	} while(!c);
	if(c==-1)
	{
		printf("ERROR: Server kann keine Verbindung empfangen...\n");
		close_jumper();
	}
	else if(c==-2)
	{
		printf("ERROR: Die Gegenseite hat die Verbindung unerwartet beendet / Protokollversion des Clients stimmt nicht...\n");
		close_jumper();
	}
	printf("DEBUG: server got connection...\n");
	netzwerk=1;
	for(counter=0;counter<1160;counter++)
		remote_feld[counter]=0;
	remote_x=-1;
	remote_y=-1;
	sync_levels=1;
}*/
		}
		if(tempint==1)
		{
			stop_playback(_MUSIC_MENU_);
			stop_playback(_MUSIC_GAME_);
			to_play=_MUSIC_GAME_;
			
			//weiterhin smooth bleiben, trotz verlorener zeit
			curSkip=maxSkip;
			reset_sem(&frame_sem, 0);
			closeme=0;		//Spiel weiterspielen
			loadnewlevel=0;
			oldlevel=level-1;
			abgelaufen=oldabgelaufen;
			
			//pacman4 neu ins feld eintragen (fr berblendung)
			tempint=0;
			while(pac4[tempint][0]!=0)
			{
				feld[pac4[tempint][1]*40 + pac4[tempint][0] + 1]=4;
				tempint++;
			}
			//pacman5 neu ins feld eintragen (fr berblendung)
			tempint=0;
			while(pac5[tempint][0]!=0)
			{
				feld[pac5[tempint][1]*40 + pac5[tempint][0] + 1]=5;
				tempint++;
			}
			//jumper neu ins feld eintragen (fr berblendung)
			feld[y*40+x+1]=7;
			if(oldlevel==level)
				bonustime=-1;
			//Level einblenden
			run_level_blender();
			//pacman4 und pacman5 wieder aus dem feld entfernen
			for(counter=0;counter<1160;counter++)
				if((feld[counter+1]==4) | (feld[counter+1]==5))
						feld[counter+1]=0;
			//jumper wieder aus dem feld entfernen
			feld[y*40+x+1]=0;
			
			abgelaufen=oldabgelaufen;
		}
		
		//Main loop
		control_count=control_frames=0;
		while(!closeme)
		{
			if(loadnewlevel)
			{
				no_frame=0;
				//Spielfeld in array feld laden
				///printf("DEBUG: Loading Level %d...",level);
				if(loadlevel(level, feld)!=0)
				{
					///printf("ERROR\nERROR: Fehler beim Laden des Spielfeldes, beende...\n");
					close_jumper();
				}
				///printf("OK\n");
				//Bonuszeit einlesen
				bonustime=feld[0];
				
				oldpunkte=0;
				oldabgelaufen=abgelaufen;
				weiterspielen=1;
				
				//Spruch einblenden
				if((oldlevel<level)&&(oldlevel!=-1))
				{
					get_spruch(rand()%70, spruch);
					init_spruch_blender(spruch);
					install_int_ex(frametimer, BPS_TO_TIMER(_SPRUCH_FPS_));
					maxSkip=_SPRUCH_SKIP_;
					reset_sem(&frame_sem, 0);
					counter=0;
					for(tempint=(SCREEN_H/2);tempint<(SCREEN_H+1);tempint+=(SCREEN_H/2))
					{
						curSkip=maxSkip;
						reset_sem(&frame_sem, 0);
						while(counter<tempint)
						{
							sem_wait(&frame_sem);
							do
							{
								counter++;
								blend_spruch(counter-12);
								if(key[KEY_SPACE])
									break;
								if(key[KEY_ESC])
									closeme=1;
								
								if((counter==tempint)||closeme)
									break;
							} while(sem_trywait(&frame_sem)==0 && ++curSkip < maxSkip);
							if(curSkip >= maxSkip)
							{
								///printf("DEBUG: Spruch-blender: Skipping frame...\n");
								reset_sem(&frame_sem, 0);
							}
							curSkip = 0;
							if(!closeme)
								show();
							else
								break;
							if(key[KEY_SPACE])
								break;
							
						}
						//5 sekunden warten, damit der spruch gelesen werden kann
						if(tempint==(SCREEN_H/2))
							for(curSkip=0;curSkip<99;curSkip++)
							{
								if(key[KEY_SPACE])
									break;
								if(key[KEY_ESC])
									closeme=1;
								if(closeme)
									break;
								rest(50);
							}
					}
					
					//Spruch ganz verschwinden lassen, bevor level eingeblendet wird
					blend_spruch(counter);
					if(!closeme)
						show();
					while(key[KEY_SPACE]);
					install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
					maxSkip=_LEVEL_SKIP_;
					unload_spruch_blender();
				}
				
				
				oldabgelaufen=abgelaufen=0;
				if(oldlevel==level)
					bonustime=-1;
				run_level_blender();
				loadnewlevel=0;
				
				
				//pacman4 startpunkt suchen
				tempint=x=0;
				y=-1;
				for(counter=0;counter<1160;counter++)
				{
					if((counter%40)==0)
						y++;
					x=(counter%40);
					if(feld[counter+1]==4)
					{
						pac4[tempint][0]=x;
						pac4[tempint][1]=y;
						pac4[tempint][2]=1;
						feld[counter+1]=0;
						tempint++;
					}
				}
				for(tempint=tempint;tempint<32;tempint++)
					pac4[tempint][0]=0;
				
				//pacman5 startpunkt suchen
				tempint=x=0;
				y=-1;
				for(counter=0;counter<1160;counter++)
				{
					if((counter%40)==0)
						y++;
					x=(counter%40);
					if(feld[counter+1]==5)
					{
						pac5[tempint][0]=x;
						pac5[tempint][1]=y;
						pac5[tempint][2]=1;
						feld[counter+1]=0;
						tempint++;
					}
				}
				for(tempint=tempint;tempint<32;tempint++)
					pac5[tempint][0]=0;
					
				//jumper startpunkt fr y-bewegung suchen
				dopsrichtung=0;
				x=0;
				y=-1;
				for(counter=0;counter<1160;counter++)
				{
					if((counter%40)==0)
						y++;
					x=(counter%40);
					if(feld[counter+1]==7)
						break;
				}
				feld[counter+1]=0;
				
				if(counter==1160)
				{
					//jumper startpunkt fr x-bewegung suchen
					dopsrichtung=1;
					x=0;
					y=-1;
					for(counter=0;counter<1160;counter++)
					{
						if((counter%40)==0)
							y++;
						x=(counter%40);
						if(feld[counter+1]==6)
							break;
					}
					feld[counter+1]=0;	
				}
				richtung=1;
				
				//Startpunkte fr Smooth eintragen
				oldx=x*16;
				oldy=y*16;
				for(tempint=0;tempint<32;tempint++)
				{
					oldpac4[tempint][0]=pac4[tempint][0]*16;
					oldpac4[tempint][1]=pac4[tempint][1]*16;
					oldpac4[tempint][2]=pac4[tempint][2]*16;
					oldpac5[tempint][0]=pac5[tempint][0]*16;
					oldpac5[tempint][1]=pac5[tempint][1]*16;
					oldpac5[tempint][2]=pac5[tempint][2]*16;
					pacinsmooth=insmooth=0;
				}
				if(netzwerk)
				{
					if(sync_levels)
					{
						write_msg(_MSG_LEVEL_START_);
						while((message_result=get_msg(_NON_BLOCKING_))==_NO_DATA_)
						{
							if(key[KEY_ESC])
								close_jumper();
							rest(1);
						}
						if(message_result!=_MSG_LEVEL_START_)
						{
							printf("ERROR: Level Start erwartet, aber %d bekommen...\n", message_result);
							close_jumper();
						}
					}
					sync_levels=1;
				}
				//erste ballumlenkung verhindern, damit ball nicht gleich umgelenkt werden kann
				waitforspace=1;
				abgelaufen=0;
				if(netzwerk==2)				//client
					no_frame=1;
				reset_sem(&frame_sem, 0);
			}
			
			///Main Frame loop
			if(netzwerk==1)					//server
			{
				sem_wait(&frame_sem);
				write_msg(_MSG_CLOCK_TICK_);
			}
			if(netzwerk)
			{
				while((message_result=get_msg(_BLOCKING_))!=_MSG_CLOCK_TICK_)
				{
					printf("MESSAGE: %d\n", message_result);
					if(message_result==_ERROR_)
					{
						printf("ERROR: Fehler beim Warten auf Clock Tick...\n");
						close_jumper();
					}
					else if(message_result==_MSG_UPDATE_)
					{
						if(get_update_data(remote_feld, &remote_x, &remote_y))
						{
							printf("ERROR: Fehler beim Updaten des remote Feldes...\n");
							close_jumper();
						}
						else
						{
							load_clean_level(feld);
							add_remote_clean_level(remote_feld);
						}
					}
					else if(message_result==_MSG_GAME_END_)
					{
						printf("Der Gegenspieler hat das Spiel beendet...\n");
						close_jumper();
					}
					else if(message_result==_MSG_LEVEL_DONE_)
					{
						punkte=0;
						oldlevel=level++;
						loadnewlevel=1;
					}
				}
				printf("MESSAGE: %d\n", message_result);
				if(netzwerk==2)
				{
					write_msg(_MSG_CLOCK_TICK_);
					sem_post(&frame_sem);
					sem_post(&frame_sem);
				}
			}
			else
			{
				
				//reset_sem(&frame_sem, 0);
				//while(!key[KEY_ESC])
				//{
					sem_wait(&frame_sem);
				//}
			}
				
			
			
///TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO _*_ TODO///
			loop_counter=0;
			global_frame_counter=0;
			do
			{
				loop_counter++;
				if(key[KEY_ESC])
				{
					oldabgelaufen=abgelaufen;
					if(!netzwerk)
						weiterspielen=1;
					closeme=1;
					loadnewlevel=1;
					//Warten bis esc wieder losgelassen wird
					while(key[KEY_ESC]);
				}
				
				if(key[KEY_P])
				{
					///TODO netzerk
					oldabgelaufen=abgelaufen;
					//warten, bis die taste losgelassen wird
					while(key[KEY_P])
					{
						rest(25);
						show();		//Damit bildschirm nicht schwarz wird
					}
					//warten bis sie wieder gedrckt wird...
					while(!key[KEY_P] && !key[KEY_ESC])
					{
						if(key[KEY_H])
						{
							while(key[KEY_H])
							{
								rest(25);
								show();		//Damit bildschirm nicht schwarz wird
							}
							save_screen();
							//bildschirm leicht schwarz berblenden
							init_message_blender(2);
							blend_all(160, _BURN_);
							unload_message_blender();
							run_message_blender(0, _NONE_, _WAITFORKEY_);		//0=help, 1=credits, 2=black
							restore_screen();
							show();
						}
						rest(25);
					}
					//...und wieder losgelassen wird
					while(key[KEY_P]) rest(25);
					//zeitbonus korrigieren
					abgelaufen=oldabgelaufen;
					//weiterhin smooth bleiben, trotz verlorener zeit
					curSkip=maxSkip;
					reset_sem(&frame_sem, 1);
				}
				if(key[KEY_H])
				{
					///TODO netzerk
					oldabgelaufen=abgelaufen;
					//warten, bis die taste losgelassen wird
					while(key[KEY_H])
					{
						rest(25);
						show();		//Damit bildschirm nicht schwarz wird
					}
					//bildschirm leicht schwarz berblenden
					init_message_blender(2);
					blend_all(160, _BURN_);
					unload_message_blender();
					run_message_blender(0, _NONE_, _WAITFORKEY_);		//0=help, 1=credits, 2=black
					//zeitbonus korrigieren
					abgelaufen=oldabgelaufen;
					//weiterhin smooth bleiben, trotz verlorener zeit
					curSkip=maxSkip;
					reset_sem(&frame_sem, 1);
				}
				
				if(key[KEY_B])
				{
					if(!back_key)
					{
						if(load_new_back(++back_num))
						{
							if(back_num!=0)
								load_new_back((back_num=0));
							else
							{
								printf("ERROR: Konnte Gamebackground nicht updaten!!!\n");
								close_jumper();
							}
						}
						load_clean_level(feld);
						add_remote_clean_level(remote_feld);
						back_key=1;
					}
				}
				else
					back_key=0;
				
				if(!insmooth)
				{
					kollision=0;
					//auf kollision mit Pacman4 prfen
					for(tempint=0;tempint<32;tempint++)
					{
						if((pac4[tempint][0]==x)&&(pac4[tempint][1]==y))
						{
							punkte=0;
							stops++;
							leben--;
							if(leben==-1)
							{
								weiterspielen=0;
								closeme=1;
								do_game_over(2);
							}
							sync_levels=0;
							loadnewlevel=1;
							oldlevel=level;
						}
						if(pac4[tempint][0]==0)
							break;
					}
					
					//auf kollision mit Pacman5 prfen
					for(tempint=0;tempint<32;tempint++)
					{
						if((pac5[tempint][0]==x)&&(pac5[tempint][1]==y))
						{
							punkte=0;
							stops++;
							leben--;
							if(leben==-1)
							{
								closeme=1;
								weiterspielen=0;
								do_game_over(2);
							}
							sync_levels=0;
							loadnewlevel=1;
							oldlevel=level;
						}
						if(pac5[tempint][0]==0)
							break;
					}
					
					//Tastaturabfragen
					insmooth=1;
					oldx=x*16;
					oldy=y*16;
//					key_code=readkey();
					clear_keybuf();
					///printf("Teste Tastatur...");
					if(dopsrichtung==0)
					{
						if(key[KEY_SPACE])
						{
							if(!waitforspace)
							{
								stops--;
								if(stops==-1)
									stops=0;
								else
								{
									if(richtung)
										richtung=0;
									else
										richtung=1;
								}
								waitforspace=1;
							}
						}
						else if(!key[KEY_SPACE])
							waitforspace=0;
						
						tempint=0;	
						if(key[KEY_LEFT])
						{
							///printf("LEFT...");
							tempint=x;
							x--;
						}
						else if(key[KEY_RIGHT])
						{
							///printf("RIGHT...");
							tempint=x;
							x++;
						}
											
						if(richtung)
						{
							y++;
							if((feld[y*40+(x+1)]==1)&&tempint)
								x=tempint;
							if(feld[y*40+(x+1)]==1)
							{	
								richtung=0;
								y--;
								waitforspace=1;
							}
						}
						else
						{
							y--;
							if((feld[y*40+(x+1)]==1)&&tempint)
								x=tempint;
							if(feld[y*40+(x+1)]==1)
							{
								richtung=1;
								y++;
								waitforspace=1;
							}
						}
						///printf("\n");
					}
					else
					{
						tempint=0;
						if(key[KEY_UP])
						{
							tempint=y;
							y--;
						}
						else if(key[KEY_DOWN])
						{
							tempint=y;
							y++;
						}
						
						if(richtung)
						{
							x++;
							if((feld[y*40+(x+1)]==1)&&tempint)
								y=tempint;
							if(feld[y*40+(x+1)]==1)
							{
								richtung=0;
								x--;
								waitforspace=1;
							}
						}
						else
						{
							x--;
							if((feld[y*40+(x+1)]==1)&&tempint)
								y=tempint;
							if(feld[y*40+(x+1)]==1)
							{
								richtung=1;
								x++;
								waitforspace=1;
							}
						}
						
						if(key[KEY_SPACE])
						{
							if(!waitforspace)
							{
								stops--;
								if(stops==-1)
									stops=0;
								else
									if(richtung)
										richtung=0;
									else
										richtung=1;
							}
							waitforspace=1;
						}
						else if(!key[KEY_SPACE])
							waitforspace=0;
					}
					
					kollision=0;
					//auf kollision mit Pacman4 prfen
					for(tempint=0;tempint<32;tempint++)
					{
						if((pac4[tempint][0]==x)&&(pac4[tempint][1]==y))
							kollision=1;
						if(pac4[tempint][0]==0)
							break;
					}
					
					//auf kollision mit Pacman5 prfen
					for(tempint=0;tempint<32;tempint++)
					{
						if((pac5[tempint][0]==x)&&(pac5[tempint][1]==y))
							kollision=1;
						if(pac5[tempint][0]==0)
							break;
					}
				}
				if(!pacinsmooth)
				{
					pacinsmooth=1;
					//Pacman4 zeichnen
					for(tempint=0;tempint<32;tempint++)
					{	
						if(pac4[tempint][0]!=0)
						{
							oldpac4[tempint][0]=pac4[tempint][0]*16;
							oldpac4[tempint][1]=pac4[tempint][1]*16;
							//oldpac4[tempint][2]=pac4[tempint][2]*16;
							
							if(pac4[tempint][2])
							{
								pac4[tempint][0]++;
								if(feld[(pac4[tempint][1])*40+(pac4[tempint][0]+1)]!=0)
								{
									pac4[tempint][2]=0;
									pac4[tempint][0]-=2;
									if(feld[(pac4[tempint][1])*40+(pac4[tempint][0]+1)]!=0)
										pac4[tempint][0]++;
								}
							}
							else
							{
								pac4[tempint][0]--;
								if(feld[(pac4[tempint][1])*40+(pac4[tempint][0]+1)]!=0)
								{
									pac4[tempint][2]=1;
									pac4[tempint][0]+=2;
									if(feld[(pac4[tempint][1])*40+(pac4[tempint][0]+1)]!=0)
										pac4[tempint][0]--;
								}
							}
							//move(2,pac4[tempint][0]*16,pac4[tempint][1]*16);
						}
						else
							break;
					}
					
					//Pacman5 zeichnen
					for(tempint=0;tempint<32;tempint++)
					{	
						if(pac5[tempint][0]!=0)
						{
							oldpac5[tempint][0]=pac5[tempint][0]*16;
							oldpac5[tempint][1]=pac5[tempint][1]*16;
							//oldpac5[tempint][2]=pac5[tempint][2]*16;
							
							if(pac5[tempint][2])
							{
								pac5[tempint][1]++;
								if(feld[(pac5[tempint][1])*40+(pac5[tempint][0]+1)]!=0)
								{
									pac5[tempint][2]=0;
									pac5[tempint][1]-=2;
									if(feld[(pac5[tempint][1])*40+(pac5[tempint][0]+1)]!=0)
										pac5[tempint][1]++;
								}
							}
							else
							{
								pac5[tempint][1]--;
								if(feld[(pac5[tempint][1])*40+(pac5[tempint][0]+1)]!=0)
								{
									pac5[tempint][2]=1;
									pac5[tempint][1]+=2;
									if(feld[(pac5[tempint][1])*40+(pac5[tempint][0]+1)]!=0)
										pac5[tempint][1]--;
								}
							}
							//move(2,pac5[tempint][0]*16,pac5[tempint][1]*16);
						}
					}
				}
				if(insmooth)
				{
					//Jumper smooth position berechnen
					if(oldx<(x*16))
					{
						oldx+=smoothpixels;
						if(oldx>(x*16))
							oldx=x*16;
					}
					else
					{
						oldx-=smoothpixels;
						if(oldx<(x*16))
							oldx=x*16;
					}
					if(oldy<(y*16))
					{
						oldy+=smoothpixels;
						if(oldy>(y*16))
							oldy=y*16;
					}
					else
					{
						oldy-=smoothpixels;
						if(oldy<(y*16))
							oldy=y*16;
					}
					//Jumper zeichnen
					if(netzwerk)
					{
						if((remote_x!=-1)&&(remote_y!=-1))
							move(_JUMPER2_TRANS_, remote_x*16, remote_y*16);
						else
							move(_JUMPER_, oldx, oldy);
						move(_JUMPER1_TRANS_, oldx, oldy);
					}
					else
						move(_JUMPER_, oldx, oldy);
	
					//Fertig bewegen?
					if((oldx==(x*16))&&(oldy==(y*16)))
					{
						if(netzwerk)
							if(write_update_msg(feld, x, y))
								printf("ERROR in write_update_msg!!!\n");
						
						//Kollision mit Herz prfen
						if(feld[y*40+(x+1)]==8)
						{
							if(herz_sound)
								play_sample(heart_sample, 255, 128, 1000, FALSE);
							punkte++;
							feld[y*40+(x+1)]=0;
							
							//herzen suchen
							herzda=0;
							for(counter=0;(counter<1160)&&(!herzda);counter++)
								if(feld[counter+1]==8)
								{
									herzda=1;
									load_clean_level(feld);
									add_remote_clean_level(remote_feld);
								}
							if(!herzda)
							{
								//Keine Herzen mehr brig....lade neues level
								//normal anzeigen
								sprintf(statustext,"Leben: %d  Stops: %d         JUMPER by Eightysoft         Level: %d  Punkte: %d", 
									leben, stops, level, allpunkte+punkte);
								print_status(statustext);
								if((bonustime-zeit_vergangen())>=1)
								{
									if(((leben+bonus)-99)>0)
									{
										if(((leben+bonus)-99)==bonus)
											stops+=bonus;
										else
										{
											leben+=(bonus-((leben+bonus)-99));
											stops+=((leben+bonus)-99);
										}
									}
									else
										leben+=bonus;
									sprintf(timetext,"Time Bonus: Erreicht");
								}
								else
									sprintf(timetext,"Time Bonus: Abgelaufen");
								print_time(timetext);
								//Pacmans zeichnen
								for(tempint=0;tempint<32;tempint++)
								{
									if((pac4[tempint][0]==0)&&(pac5[tempint][0]==0))
										break;
									if(pac4[tempint][0]!=0)
										move(_PACMAN_, oldpac4[tempint][0], oldpac4[tempint][1]);
									//Pacman5 berechnen
									if(pac5[tempint][0]!=0)
										move(_PACMAN_, oldpac5[tempint][0], oldpac5[tempint][1]);
								}
								//Bildschirm aktualisieren
								show();
								allpunkte+=punkte;
								punkte=0;
								oldlevel=level++;
								if(netzwerk)
									if(write_msg(_MSG_LEVEL_DONE_))
										printf("ERROR in write_msg: level_done\n");
								allpunkte+=punkte;
								punkte=0;
								loadnewlevel=1;
							}
							oldpunkte=punkte;
						}
						//Kollision mit Stachelkugel (2) prfen
						if(feld[y*40+(x+1)]==2)
						{
							punkte=0;
							stops++;
							leben--;
							if(leben==-1)
							{
								closeme=1;
								weiterspielen=0;
								do_game_over(2);
							}
							sync_levels=0;
							loadnewlevel=1;
							oldlevel=level;
						}
						//Kollision mit Stachelkugel (3) prfen
						else if(feld[y*40+(x+1)]==3)
						{
							punkte=0;
							stops++;
							leben--;
							if(leben==-1)
							{
								weiterspielen=0;
								closeme=1;
								do_game_over(2);
							}
							sync_levels=0;
							loadnewlevel=1;
							oldlevel=level;
						}
						//Kollision mit Pacman
						if(kollision)
						{
							punkte=0;
							stops++;
							leben--;
							if(leben==-1)
							{
								closeme=1;
								weiterspielen=0;
								do_game_over(2);
							}
							sync_levels=0;
							loadnewlevel=1;
							oldlevel=level;
						}
						insmooth=0;
					}
				}
				if(pacinsmooth)
				{
					//Pacmans smooth zeichnen
					for(tempint=0;tempint<32;tempint++)
					{
						if((pac4[tempint][0]==0)&&(pac5[tempint][0]==0))
							break;
						
						//Pacman4 berechnen
						if(pac4[tempint][0]!=0)
						{
							//neue x-Koordinate smooth berechnen
							if(oldpac4[tempint][0]<(pac4[tempint][0]*16))
							{
								oldpac4[tempint][0]+=smoothpixels;
								if(oldpac4[tempint][0]>(pac4[tempint][0]*16))
									oldpac4[tempint][0]=pac4[tempint][0]*16;
							}
							else
							{
								oldpac4[tempint][0]-=smoothpixels;
								if(oldpac4[tempint][0]<(pac4[tempint][0]*16))
									oldpac4[tempint][0]=pac4[tempint][0]*16;
							}
							//neue y-koordinate smooth berechnen
							if(oldpac4[tempint][1]<(pac4[tempint][1]*16))
							{
								oldpac4[tempint][1]+=smoothpixels;
								if(oldpac4[tempint][1]>(pac4[tempint][1]*16))
									oldpac4[tempint][1]=pac4[tempint][1]*16;
							}
							else
							{
								oldpac4[tempint][1]-=smoothpixels;
								if(oldpac4[tempint][1]<(pac4[tempint][1]*16))
									oldpac4[tempint][1]=pac4[tempint][1]*16;
							}
							move(_PACMAN_, oldpac4[tempint][0], oldpac4[tempint][1]);
						}
						//Pacman5 berechnen
						if(pac5[tempint][0]!=0)
						{
							//neue x-Koordinate smooth berechnen
							if(oldpac5[tempint][0]<(pac5[tempint][0]*16))
							{
								oldpac5[tempint][0]+=smoothpixels;
								if(oldpac5[tempint][0]>(pac5[tempint][0]*16))
									oldpac5[tempint][0]=pac5[tempint][0]*16;
							}
							else
							{
								oldpac5[tempint][0]-=smoothpixels;
								if(oldpac5[tempint][0]<(pac5[tempint][0]*16))
									oldpac5[tempint][0]=pac5[tempint][0]*16;
							}
							//neue y-koordinate smooth berechnen
							if(oldpac5[tempint][1]<(pac5[tempint][1]*16))
							{
								oldpac5[tempint][1]+=smoothpixels;
								if(oldpac5[tempint][1]>(pac5[tempint][1]*16))
									oldpac5[tempint][1]=pac5[tempint][1]*16;
							}
							else
							{
								oldpac5[tempint][1]-=smoothpixels;
								if(oldpac5[tempint][1]<(pac5[tempint][1]*16))
									oldpac5[tempint][1]=pac5[tempint][1]*16;
							}
							move(_PACMAN_, oldpac5[tempint][0], oldpac5[tempint][1]);
						}
					}
					
					//Pacmans fertig bewegen?
					pacok=0;
					for(tempint=0;tempint<32;tempint++)
					{
						if(oldpac4[tempint][0]!=(pac4[tempint][0]*16))
							pacok=1;
						if(oldpac4[tempint][1]!=(pac4[tempint][1]*16))
							pacok=1;
						if(oldpac5[tempint][0]!=(pac5[tempint][0]*16))
							pacok=1;
						if(oldpac5[tempint][1]!=(pac5[tempint][1]*16))
						pacok=1;
					}
					if(!pacok)
						pacinsmooth=0;
				}
				
				if(closeme || loadnewlevel)
					break;
				
				//normal anzeigen
				sprintf(statustext,"Leben: %d  Stops: %d         JUMPER by Eightysoft         Level: %d  Punkte: %d", 
						leben, stops, level, allpunkte+punkte);
				print_status(statustext);
				//time_bonus counter
				if(bonustime-zeit_vergangen()>=1)
				{
					if(((leben+bonus)-99)>0)
					{
						if(((leben+bonus)-99)==bonus)
							sprintf(timetext,"Time Bonus (%d Stops): Noch %d sec.", (bonus), (int)(bonustime-zeit_vergangen()));
						else
							sprintf(timetext,"Time Bonus (%d Leben, %d Stops): Noch %d sec.", (bonus-((leben+bonus)-99)), ((leben+bonus)-99), (int)(bonustime-zeit_vergangen()));
					}
					else
						sprintf(timetext,"Time Bonus (%d Leben): Noch %d sec.", (bonus), (int)(bonustime-zeit_vergangen()));
				}
				else
					sprintf(timetext,"Time Bonus: Abgelaufen");
				print_time(timetext);
				
				//bersprungene frames zhlen
				curSkip++;
			} while((sem_trywait(&frame_sem)==0) && (curSkip < maxSkip));
			control_count++;
			if(curSkip >= maxSkip)
			{
				control_frames++;
				///printf("DEBUG: Main Frame-loop: Skipping frame... [%d >= %d] -- smoothpixels: %d\n", curSkip, maxSkip, smoothpixels);
				reset_sem(&frame_sem, 0);
			}
			curSkip = 0;
			
			//Anzeige aktualisieren
			if(loadnewlevel)
			{
				//anzeige, wenn neues level geladen wird nicht verndern, da berblendung
				reload_doublebuffer();
			}
			//Bildschirm aktualisieren
			if(!closeme)
				show();
///			printf("global_frame_counter=%d, loop_counter=%d\n", global_frame_counter, loop_counter);
			if(control_count>4)
			{
				if(control_omit<16)
					control_omit++;
				if(((float)control_frames/control_count)>0.5)
				{
					if(smoothpixels<16)
					{
						smoothpixels*=2;
						install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
						maxSkip=_LEVEL_SKIP_;
						if(control_omit<16)
							control_grenze=smoothpixels;
					}
				}
				else if(((float)control_frames/control_count)<=0.2)
				{
					if(smoothpixels>control_grenze)
					{
						if(smoothpixels>1)
						{
							smoothpixels/=2;
							install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
							maxSkip=_LEVEL_SKIP_;
							control_omit=0;
						}
					}
				}
///				printf("control_grenze= %d, quotient: %f, smoothpixels=%d\n", control_grenze, ((float)control_frames/control_count), smoothpixels);
				control_count=0;
				control_frames=0;
			}
		}
	}
	
	//beenden
	close_jumper();
	//wird nie erreicht
	return 1;
} 
END_OF_MAIN();


void close_jumper(void)
{
	///printf("DEBUG: Closing down...");
	run_key_thread=0;
	pthread_join(*key_thread_id, NULL);
	stop_playback(_MUSIC_MENU_);
	stop_playback(_MUSIC_GAME_);
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	sem_close(&frame_sem);
	allegro_exit();
	///printf("OK\n");
	exit(0);
}

int do_jumper_menu(void)
{
	int tempint, oldy;
	
	stop_playback(_MUSIC_MENU_);
	stop_playback(_MUSIC_GAME_);
	to_play=_MUSIC_MENU_;
	if(weiterspielen)
		tempint=_ENABLED_;
	else
		tempint=_DISABLED_;
	if(prepare_menu(_MAIN_MENU_, tempint))
	{
		printf("ERROR: Konnte Men nicht erstellen!!!\n");
		close_jumper();
	}
	
	closeme=0;
	run_menu_blender();
	
	tempint=0;
	while(1)
	{
		oldy=tempint;
		if(key[KEY_B])
		{
			if(load_new_back(++back_num))
			{
				if(back_num!=0)
					load_new_back((back_num=0));
				else
				{
					printf("ERROR: Konnte Menbackground nicht updaten!!!\n");
					close_jumper();
				}
			}
			update_jumper_menu();
			while(key[KEY_B])
			{
				rest(25);
				show();
			}
		}
		if(key[KEY_ESC])
		{
			if(weiterspielen)
				//Zurck zu game
				tempint=1;
			else
				//beenden
				tempint=2;
			//Warten bis esc wieder losgelassen wird
			while(key[KEY_ESC]);
			break;
		}
		if(key[KEY_UP])
			tempint--;
		if(key[KEY_DOWN])
			tempint++;
		while(1)
		{
			if(tempint<0)
				tempint=get_menu_items();
			if(tempint>get_menu_items())
				tempint=0;
			if(get_item_property(tempint)!=_DISABLED_)
				break;
			else
			{
				if(oldy<tempint)
					tempint++;
				else if(oldy>tempint)
					tempint--;
			}
		}
		set_item_property(oldy, _ENABLED_);
		set_item_property(tempint, _MARKED_);
		if(tempint!=oldy)
		{
			if(update_jumper_menu())
			{
				printf("ERROR: Konnte Men nicht updaten!!!\n");
				close_jumper();
			}
			show();
			rest(50);
		}
		if(key[KEY_ENTER])
			break;
		rest(50);
	}
	
	return tempint;
}

void reset_window(void)
{
	save_screen();
	tempint=set_graphic_mode(800,600, (old_mode=(old_mode==_WINDOW_ ? _FULLSCREEN_ : _WINDOW_)));
	set_screen_pos((SCREEN_W-640)/2, (SCREEN_H-480)/2);
	//Grafikmodus setzen
	if(tempint==1)
	{
		printf("ERROR: Grafikmodus nicht verfgbar\n");
		exit(1);
	}
	else if(tempint==2)
	{
		printf("ERROR: Konnte Bilddateien nicht laden...\n");
		exit(2);
	}
	else if(tempint==3)
	{
		printf("ERROR: Konnte keinen DoubleBuffer erstellen...\n");
		exit(3);
	}
	restore_screen();
	show();
	return;
}

void do_game_over(int multi)
{
	install_int_ex(frametimer, BPS_TO_TIMER(_BLEND_FPS_*multi));
	maxSkip=_BLEND_SKIP_;
	curSkip=0;
	reset_sem(&frame_sem, 0);
	counter=0;
	tempint=192;
	while(counter<tempint)
	{
		sem_wait(&frame_sem);
		do
		{
			counter++;
			blend_game_over(counter);
		} while((sem_trywait(&frame_sem)==0) && (++curSkip < maxSkip) && (counter<tempint));
		if(curSkip >= maxSkip)
		{
			///printf("DEBUG: Gameover-blender: Skipping frame...\n");
			reset_sem(&frame_sem, 0);
		}
		curSkip=0;
		show();
	}
	install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
	maxSkip=_LEVEL_SKIP_;
	curSkip=maxSkip;
	return;
}

void run_menu_blender(void)
{
	install_int_ex(frametimer, BPS_TO_TIMER(_BLEND_FPS_));
	maxSkip=_BLEND_SKIP_;
	curSkip=0;
	reset_sem(&frame_sem, 0);
	counter=0;
	while(counter<(first_menu? 48 : 72))
	{
		sem_wait(&frame_sem);
		do
		{
			counter++;
			if(!first_menu)
				counter++;
			blend_all(counter, first_menu ? _DISSOLVE_ : _TRANS_);
		} while((sem_trywait(&frame_sem)==0) && (++curSkip < maxSkip) && (counter<(first_menu? 48 : 72)));
		if(curSkip >= maxSkip)
		{
			///printf("DEBUG: Menu-blender: Skipping frame...\n");
			reset_sem(&frame_sem, 0);
		}
		curSkip=0;
		show();
	}
	blend_all(255, _NONE_);
	show();
	while(key[KEY_ESC])
		rest(25);
	unload_menu_blender();
	install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
	maxSkip=_LEVEL_SKIP_;
	curSkip=maxSkip;
	first_menu=1;
	return;
}

void run_message_blender(int message, int type, int wait)
{
	if(type==_DISSOLVE_)
		tempint=72;
	else
		tempint=48;
	init_message_blender(message);
	install_int_ex(frametimer, BPS_TO_TIMER(_BLEND_FPS_));
	maxSkip=_BLEND_SKIP_;
	curSkip=0;
	reset_sem(&frame_sem, 0);
	if(type!=_NONE_)
	{
		counter=0;
		while(counter<tempint)
		{
			sem_wait(&frame_sem);
			do
			{
				if(type==_DISSOLVE_)
				{
					counter+=2;
					blend_all(counter, type);
				}
				else
				{
					counter++;
					blend_all(counter, type);
				}
			} while((sem_trywait(&frame_sem)==0) && (++curSkip < maxSkip) && (counter<tempint));
			if(curSkip >= maxSkip)
			{
				///printf("DEBUG: Message-blender: Skipping frame...\n");
				reset_sem(&frame_sem, 0);
			}
			curSkip=0;
			show();
		}
	}
	blend_all(255, type);
	show();
	if(wait)
	{
		while(!(key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_ESC] || key[KEY_H]))
			rest(25);
		while(key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_ESC] || key[KEY_H])
			rest(25);
	}
	
	unload_message_blender();
	install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
	maxSkip=_LEVEL_SKIP_;
	curSkip=maxSkip;
	return;
}

void run_level_blender(void)
{
	//Level einblenden
	if(oldlevel<level)
		tempint=72;
	if(oldlevel==level)
		tempint=48;
	//Statustext aktualisieren
	sprintf(statustext,"Leben: %d  Stops: %d         JUMPER by Eightysoft         Level: %d  Punkte: %d", 
		leben, stops, level, allpunkte+punkte);
	set_status(statustext);
	zeit=bonustime-zeit_vergangen();
	if(zeit<1)
		sprintf(timetext,"Time Bonus: Abgelaufen");
	else
		if(((leben+bonus)-99)>0)
			if(((leben+bonus)-99)==bonus)
				sprintf(timetext,"Time Bonus (%d Stops): Noch %d sec.",
					(bonus), zeit);
			else
				sprintf(timetext,"Time Bonus (%d Leben, %d Stops): Noch %d sec.",
					(bonus-((leben+bonus)-99)), ((leben+bonus)-99), zeit);
		else
			sprintf(timetext,"Time Bonus (%d Leben): Noch %d sec.",
					(bonus), zeit);
	set_time(timetext);
	init_level_blender(feld);
	add_remote_clean_level(remote_feld);
	install_int_ex(frametimer, BPS_TO_TIMER(_BLEND_FPS_));
	maxSkip=_BLEND_SKIP_;
	curSkip=0;
	reset_sem(&frame_sem, 0);
	counter=0;
	while(counter<tempint)
	{
		sem_wait(&frame_sem);
		do
		{
			if(oldlevel<level)
			{
				counter+=2;
				blend_all(counter,_DISSOLVE_);
			}
			if(oldlevel==level)
			{
				counter++;
				blend_all(counter,_TRANS_);
			}
			
			if(key[KEY_ESC])
				closeme=1;
			
			if(closeme)
				break;
		} while((sem_trywait(&frame_sem)==0 && ++curSkip < maxSkip)&&(counter<tempint));
		if(curSkip >= maxSkip)
		{
			///printf("DEBUG: Level-blender: Skipping frame...\n");
			reset_sem(&frame_sem, 0);
		}
		curSkip=0;
		if(closeme)
			break;
		show();
	}
	if(oldlevel<level)
		blend_all(255,_NONE_);
	if(oldlevel==level)
		blend_all(255,_NONE_);
	show();
	while(key[KEY_ESC])
		rest(25);
	unload_level_blender();
	install_int_ex(frametimer, BPS_TO_TIMER(_FPS_));
	maxSkip=_LEVEL_SKIP_;
	curSkip=maxSkip;
	return;
}

inline float zeit_vergangen(void)
{
	return (float)abgelaufen / timer_interval;
}


