#include <allegro.h>

#include "menu.h"
#define _MAX_ITEMS_	128

int frei;			//Anzahl der erstellten Buttons
int item_data[_MAX_ITEMS_];	//Eigenschaften

BITMAP *items[_MAX_ITEMS_][3];	//Men_Button speicher
BITMAP *menu_back;		//Hintergrundbild



void init_jumper_menu(void) {

	int counter, i;

	frei=0;
	for(counter=0; counter<_MAX_ITEMS_;counter++) {
		for(i=0; i<3; i++)
			items[counter][i]=NULL;
		item_data[counter]=0;
	}
	menu_back=NULL;
	frei=0;
	return;
}

int clear_menu(BITMAP *hintergrund) {

	int counter, i;

	for(counter=0; counter<frei;counter++) {
		for(i=0; i<3; i++) {
			destroy_bitmap(items[counter][i]);
			items[counter][i]=NULL;
		}
		item_data[counter]=0;
	}
	if(menu_back!=NULL)
		destroy_bitmap(menu_back);
	if((menu_back=create_bitmap(hintergrund->w, hintergrund->h))==NULL)
		return 1;
	update_back(hintergrund);
	frei=0;
	return 0;
}

void update_back(BITMAP *hintergrund)
{
	acquire_bitmap(menu_back);
	acquire_bitmap(hintergrund);
	blit(hintergrund, menu_back, 0, 0, 0, 0, hintergrund->w, hintergrund->h);
	release_bitmap(hintergrund);
	release_bitmap(menu_back);
	return;
}

int add_item(BITMAP *button_bild1, BITMAP *button_bild2, BITMAP *button_bild3, int button_enabled) {
	
	if((items[frei][0] = create_bitmap(button_bild1->w, button_bild1->h))==NULL)
		return 1;
	if((items[frei][1] = create_bitmap(button_bild2->w, button_bild2->h))==NULL) {
		destroy_bitmap(items[frei][0]);
		return 1;
	}
	if((items[frei][2] = create_bitmap(button_bild3->w, button_bild3->h))==NULL) {
		destroy_bitmap(items[frei][0]);
		destroy_bitmap(items[frei][1]);
		return 1;
	}
	acquire_bitmap(items[frei][0]);
	acquire_bitmap(items[frei][1]);
	acquire_bitmap(items[frei][2]);
	blit(button_bild1, items[frei][0], 0, 0, 0, 0, button_bild1->w, button_bild1->h);
	blit(button_bild2, items[frei][1], 0, 0, 0, 0, button_bild2->w, button_bild2->h);
	blit(button_bild3, items[frei][2], 0, 0, 0, 0, button_bild3->w, button_bild3->h);
	release_bitmap(items[frei][0]);
	release_bitmap(items[frei][1]);
	release_bitmap(items[frei][2]);
	item_data[frei]=button_enabled;
	frei++;
	return 0;
}

int draw_menu(BITMAP *destination, int padding) {

	int x = 0;
	int y = 0;
	int counter;

	acquire_bitmap(destination);	

	stretch_blit(menu_back, destination, 0, 0, menu_back->w, menu_back->h, 0, 0, destination->w, destination->h);
	for(counter=0;counter<frei;counter++) {
		y += items[counter][0]->h;
	}
	y = (destination->h - (y + (frei * padding))) / 2;

	for(counter=0; counter<frei; counter++) {
		x = (destination->w - items[counter][item_data[counter]]->w) / 2;
		draw_sprite(destination, items[counter][item_data[counter]], x, y);
		y += items[counter][0]->h + padding;
	}
	release_bitmap(destination);
	return 0;
}

void set_item_property(int itemnum, int prop) {

	item_data[itemnum]=prop;
	return;
}

int get_menu_items(void)
{
	return frei-1;
}

int get_item_property(int itemnum)
{
	return item_data[itemnum];
}

